## coding: utf-8

# flake8: noqa

"""
    Purplship Open Source Multi-carrier Shipping API

     Purplship is an open source multi-carrier shipping API that simplifies the integration of logistic carrier services  The **proxy** endpoints are stateless and forwards calls to carriers web services.   # noqa: E501

    OpenAPI spec version: v1-2021.2
    Contact: hello@purplship.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import
import typing

# import apis into sdk package
from purplship.api.api_api import APIApi
from purplship.api.addresses_api import AddressesApi
from purplship.api.carriers_api import CarriersApi
from purplship.api.customs_api import CustomsApi
from purplship.api.parcels_api import ParcelsApi
from purplship.api.pickups_api import PickupsApi
from purplship.api.proxy_api import ProxyApi
from purplship.api.shipments_api import ShipmentsApi
from purplship.api.trackers_api import TrackersApi
from purplship.api.webhooks_api import WebhooksApi
# import ApiClient
from purplship.api_client import ApiClient
from purplship.configuration import Configuration


api_key = None
api_key_prefix = 'Token'
host = None
api_client = None
configuration = Configuration()


def init_client():
    global api_client
    global configuration
    if (api_client is not None) and (configuration.host == host) \
            and (configuration.api_key['Authorization'] == f'{api_key_prefix} {api_key}'):
        return api_client

    configuration = Configuration()
    configuration.host = host
    configuration.api_key['Authorization'] = f'{api_key_prefix} {api_key}'
    api_client = ApiClient(configuration)

    return api_client


def define_api(api_class: typing.Type):
    class _API(api_class):
        def __init__(self):
            pass

        def __getattribute__(self, item):
            return getattr(api_class(init_client()), item)

    return _API()


API = define_api(APIApi)
Addresses = define_api(AddressesApi)
Carriers = define_api(CarriersApi)
Customs = define_api(CustomsApi)
Parcels = define_api(ParcelsApi)
Pickups = define_api(PickupsApi)
Proxy = define_api(ProxyApi)
Shipments = define_api(ShipmentsApi)
Trackers = define_api(TrackersApi)
Webhooks = define_api(WebhooksApi)
