# coding: utf-8

# flake8: noqa
"""
    Purplship API

     ## API Reference  Purplship is an open source multi-carrier shipping API that simplifies the integration of logistic carrier services.  The Purplship API is organized around REST. Our API has predictable resource-oriented URLs, accepts JSON-encoded  request bodies, returns JSON-encoded responses, and uses standard HTTP response codes, authentication, and verbs.  The Purplship API differs for every account as we release new versions. These docs are customized to your version of the API.   ## Versioning  When backwards-incompatible changes are made to the API, a new, dated version is released.  The current version is `2021.6.2`.   Read our API changelog and to learn more about backwards compatibility.  As a precaution, use API versioning to check a new API version before committing to an upgrade.   ## Pagination  All top-level API resources have support for bulk fetches via \"list\" API methods. For instance, you can list addresses,  list shipments, and list trackers. These list API methods share a common structure, taking at least these  two parameters: limit, and offset.  Purplship utilizes offset-based pagination via the offset and limit parameters. Both parameters take a number as value (see below) and return objects in reverse chronological order.  The offset parameter returns objects listed after an index.  The limit parameter take a limit on the number of objects to be returned from 1 to 100.   ```json {     \"next\": \"/v1/shipments?limit=25&offset=25\",     \"previous\": \"/v1/shipments?limit=25&offset=25\",     \"results\": [     ] } ```  ## Environments  The Purplship API offer the possibility to create and retrieve certain objects in `test_mode`. In development, it is therefore possible to add carrier connections, get live rates,  buy labels, create trackers and schedule pickups in `test_mode`.    # noqa: E501

    OpenAPI spec version: 2021.6.2
    Contact: hello@purplship.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

# import models into model package
from purplship.models.access_token import AccessToken
from purplship.models.address import Address
from purplship.models.address_data import AddressData
from purplship.models.address_list import AddressList
from purplship.models.address_validation import AddressValidation
from purplship.models.carrier_list import CarrierList
from purplship.models.carrier_settings import CarrierSettings
from purplship.models.charge import Charge
from purplship.models.commodity import Commodity
from purplship.models.commodity_data import CommodityData
from purplship.models.customs import Customs
from purplship.models.customs_data import CustomsData
from purplship.models.customs_list import CustomsList
from purplship.models.duty import Duty
from purplship.models.error_response import ErrorResponse
from purplship.models.message import Message
from purplship.models.operation import Operation
from purplship.models.operation_confirmation import OperationConfirmation
from purplship.models.operation_response import OperationResponse
from purplship.models.parcel import Parcel
from purplship.models.parcel_data import ParcelData
from purplship.models.parcel_list import ParcelList
from purplship.models.payment import Payment
from purplship.models.pickup import Pickup
from purplship.models.pickup_cancel_data import PickupCancelData
from purplship.models.pickup_cancel_request import PickupCancelRequest
from purplship.models.pickup_data import PickupData
from purplship.models.pickup_list import PickupList
from purplship.models.pickup_request import PickupRequest
from purplship.models.pickup_response import PickupResponse
from purplship.models.pickup_update_data import PickupUpdateData
from purplship.models.pickup_update_request import PickupUpdateRequest
from purplship.models.rate import Rate
from purplship.models.rate_request import RateRequest
from purplship.models.rate_response import RateResponse
from purplship.models.references import References
from purplship.models.shipment import Shipment
from purplship.models.shipment_cancel_request import ShipmentCancelRequest
from purplship.models.shipment_data import ShipmentData
from purplship.models.shipment_list import ShipmentList
from purplship.models.shipment_purchase_data import ShipmentPurchaseData
from purplship.models.shipping_request import ShippingRequest
from purplship.models.token_obtain_pair import TokenObtainPair
from purplship.models.token_pair import TokenPair
from purplship.models.token_refresh import TokenRefresh
from purplship.models.token_verify import TokenVerify
from purplship.models.tracker_list import TrackerList
from purplship.models.tracking_event import TrackingEvent
from purplship.models.tracking_response import TrackingResponse
from purplship.models.tracking_status import TrackingStatus
from purplship.models.webhook import Webhook
from purplship.models.webhook_data import WebhookData
from purplship.models.webhook_list import WebhookList
from purplship.models.webhook_test_request import WebhookTestRequest
