# coding: utf-8

"""
    Purplship API

     ## API Reference  Purplship is an open source multi-carrier shipping API that simplifies the integration of logistic carrier services.  The Purplship API is organized around REST. Our API has predictable resource-oriented URLs, accepts JSON-encoded  request bodies, returns JSON-encoded responses, and uses standard HTTP response codes, authentication, and verbs.  The Purplship API differs for every account as we release new versions. These docs are customized to your version of the API.   ## Versioning  When backwards-incompatible changes are made to the API, a new, dated version is released.  The current version is `2021.6.2`.   Read our API changelog and to learn more about backwards compatibility.  As a precaution, use API versioning to check a new API version before committing to an upgrade.   ## Pagination  All top-level API resources have support for bulk fetches via \"list\" API methods. For instance, you can list addresses,  list shipments, and list trackers. These list API methods share a common structure, taking at least these  two parameters: limit, and offset.  Purplship utilizes offset-based pagination via the offset and limit parameters. Both parameters take a number as value (see below) and return objects in reverse chronological order.  The offset parameter returns objects listed after an index.  The limit parameter take a limit on the number of objects to be returned from 1 to 100.   ```json {     \"next\": \"/v1/shipments?limit=25&offset=25\",     \"previous\": \"/v1/shipments?limit=25&offset=25\",     \"results\": [     ] } ```  ## Environments  The Purplship API offer the possibility to create and retrieve certain objects in `test_mode`. In development, it is therefore possible to add carrier connections, get live rates,  buy labels, create trackers and schedule pickups in `test_mode`.    # noqa: E501

    OpenAPI spec version: 2021.6.2
    Contact: hello@purplship.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PickupCancelRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'confirmation_number': 'str',
        'address': 'AddressData',
        'pickup_date': 'str',
        'reason': 'str'
    }

    attribute_map = {
        'confirmation_number': 'confirmation_number',
        'address': 'address',
        'pickup_date': 'pickup_date',
        'reason': 'reason'
    }

    def __init__(self, confirmation_number=None, address=None, pickup_date=None, reason=None):  # noqa: E501
        """PickupCancelRequest - a model defined in Swagger"""  # noqa: E501
        self._confirmation_number = None
        self._address = None
        self._pickup_date = None
        self._reason = None
        self.discriminator = None
        self.confirmation_number = confirmation_number
        if address is not None:
            self.address = address
        if pickup_date is not None:
            self.pickup_date = pickup_date
        if reason is not None:
            self.reason = reason

    @property
    def confirmation_number(self):
        """Gets the confirmation_number of this PickupCancelRequest.  # noqa: E501

        The pickup confirmation identifier  # noqa: E501

        :return: The confirmation_number of this PickupCancelRequest.  # noqa: E501
        :rtype: str
        """
        return self._confirmation_number

    @confirmation_number.setter
    def confirmation_number(self, confirmation_number):
        """Sets the confirmation_number of this PickupCancelRequest.

        The pickup confirmation identifier  # noqa: E501

        :param confirmation_number: The confirmation_number of this PickupCancelRequest.  # noqa: E501
        :type: str
        """
        if confirmation_number is None:
            raise ValueError("Invalid value for `confirmation_number`, must not be `None`")  # noqa: E501

        self._confirmation_number = confirmation_number

    @property
    def address(self):
        """Gets the address of this PickupCancelRequest.  # noqa: E501


        :return: The address of this PickupCancelRequest.  # noqa: E501
        :rtype: AddressData
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this PickupCancelRequest.


        :param address: The address of this PickupCancelRequest.  # noqa: E501
        :type: AddressData
        """

        self._address = address

    @property
    def pickup_date(self):
        """Gets the pickup_date of this PickupCancelRequest.  # noqa: E501

         The pickup date  Date Format: `YYYY-MM-DD`   # noqa: E501

        :return: The pickup_date of this PickupCancelRequest.  # noqa: E501
        :rtype: str
        """
        return self._pickup_date

    @pickup_date.setter
    def pickup_date(self, pickup_date):
        """Sets the pickup_date of this PickupCancelRequest.

         The pickup date  Date Format: `YYYY-MM-DD`   # noqa: E501

        :param pickup_date: The pickup_date of this PickupCancelRequest.  # noqa: E501
        :type: str
        """

        self._pickup_date = pickup_date

    @property
    def reason(self):
        """Gets the reason of this PickupCancelRequest.  # noqa: E501

        The reason of the pickup cancellation  # noqa: E501

        :return: The reason of this PickupCancelRequest.  # noqa: E501
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this PickupCancelRequest.

        The reason of the pickup cancellation  # noqa: E501

        :param reason: The reason of this PickupCancelRequest.  # noqa: E501
        :type: str
        """

        self._reason = reason

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PickupCancelRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PickupCancelRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
