# coding: utf-8

"""
    Purplship API

     ## API Reference  Purplship is an open source multi-carrier shipping API that simplifies the integration of logistic carrier services.  The Purplship API is organized around REST. Our API has predictable resource-oriented URLs, accepts JSON-encoded  request bodies, returns JSON-encoded responses, and uses standard HTTP response codes, authentication, and verbs.  The Purplship API differs for every account as we release new versions. These docs are customized to your version of the API.   ## Versioning  When backwards-incompatible changes are made to the API, a new, dated version is released.  The current version is `2021.6.2`.   Read our API changelog and to learn more about backwards compatibility.  As a precaution, use API versioning to check a new API version before committing to an upgrade.   ## Pagination  All top-level API resources have support for bulk fetches via \"list\" API methods. For instance, you can list addresses,  list shipments, and list trackers. These list API methods share a common structure, taking at least these  two parameters: limit, and offset.  Purplship utilizes offset-based pagination via the offset and limit parameters. Both parameters take a number as value (see below) and return objects in reverse chronological order.  The offset parameter returns objects listed after an index.  The limit parameter take a limit on the number of objects to be returned from 1 to 100.   ```json {     \"next\": \"/v1/shipments?limit=25&offset=25\",     \"previous\": \"/v1/shipments?limit=25&offset=25\",     \"results\": [     ] } ```  ## Environments  The Purplship API offer the possibility to create and retrieve certain objects in `test_mode`. In development, it is therefore possible to add carrier connections, get live rates,  buy labels, create trackers and schedule pickups in `test_mode`.    # noqa: E501

    OpenAPI spec version: 2021.6.2
    Contact: hello@purplship.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class TrackingEvent(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        '_date': 'str',
        'description': 'str',
        'location': 'str',
        'code': 'str',
        'time': 'str'
    }

    attribute_map = {
        '_date': 'date',
        'description': 'description',
        'location': 'location',
        'code': 'code',
        'time': 'time'
    }

    def __init__(self, _date=None, description=None, location=None, code=None, time=None):  # noqa: E501
        """TrackingEvent - a model defined in Swagger"""  # noqa: E501
        self.__date = None
        self._description = None
        self._location = None
        self._code = None
        self._time = None
        self.discriminator = None
        if _date is not None:
            self._date = _date
        if description is not None:
            self.description = description
        if location is not None:
            self.location = location
        if code is not None:
            self.code = code
        if time is not None:
            self.time = time

    @property
    def _date(self):
        """Gets the _date of this TrackingEvent.  # noqa: E501

        The tracking event's date  # noqa: E501

        :return: The _date of this TrackingEvent.  # noqa: E501
        :rtype: str
        """
        return self.__date

    @_date.setter
    def _date(self, _date):
        """Sets the _date of this TrackingEvent.

        The tracking event's date  # noqa: E501

        :param _date: The _date of this TrackingEvent.  # noqa: E501
        :type: str
        """

        self.__date = _date

    @property
    def description(self):
        """Gets the description of this TrackingEvent.  # noqa: E501

        The tracking event's description  # noqa: E501

        :return: The description of this TrackingEvent.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TrackingEvent.

        The tracking event's description  # noqa: E501

        :param description: The description of this TrackingEvent.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def location(self):
        """Gets the location of this TrackingEvent.  # noqa: E501

        The tracking event's location  # noqa: E501

        :return: The location of this TrackingEvent.  # noqa: E501
        :rtype: str
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this TrackingEvent.

        The tracking event's location  # noqa: E501

        :param location: The location of this TrackingEvent.  # noqa: E501
        :type: str
        """

        self._location = location

    @property
    def code(self):
        """Gets the code of this TrackingEvent.  # noqa: E501

        The tracking event's code  # noqa: E501

        :return: The code of this TrackingEvent.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this TrackingEvent.

        The tracking event's code  # noqa: E501

        :param code: The code of this TrackingEvent.  # noqa: E501
        :type: str
        """

        self._code = code

    @property
    def time(self):
        """Gets the time of this TrackingEvent.  # noqa: E501

        The tracking event's time  # noqa: E501

        :return: The time of this TrackingEvent.  # noqa: E501
        :rtype: str
        """
        return self._time

    @time.setter
    def time(self, time):
        """Sets the time of this TrackingEvent.

        The tracking event's time  # noqa: E501

        :param time: The time of this TrackingEvent.  # noqa: E501
        :type: str
        """

        self._time = time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TrackingEvent, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TrackingEvent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
